#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# generated by wxGlade 0.4.1 on Mon Nov 27 14:32:11 2006

import wx
import wx.grid as  gridlib
import globals
import os      

class MyDialogMoreCds(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyDialogMoreCds.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.panel_2 = wx.Panel(self, -1)
        self.grid_multiupload = wx.grid.Grid(self.panel_2, -1, size=(1, 1))
        self.button_cancel = wx.Button(self.panel_2, -1, "Cancel")
        self.button_accept = wx.Button(self.panel_2, -1, "Accept")

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyDialogMoreCds.__set_properties
        self.SetTitle("Upload More Subtitles")
        self.grid_multiupload.CreateGrid(1, 1)
        self.grid_multiupload.EnableEditing(0)
        self.grid_multiupload.SetColLabelValue(0, "File")
        self.grid_multiupload.SetMinSize((400, 233))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyDialogMoreCds.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add(self.grid_multiupload, 1, wx.EXPAND, 0)
        sizer_4.Add((20, 0), 1, wx.ADJUST_MINSIZE, 0)
        sizer_4.Add(self.button_cancel, 0, wx.RIGHT|wx.ADJUST_MINSIZE, 4)
        sizer_4.Add(self.button_accept, 0, wx.ADJUST_MINSIZE, 0)
        sizer_2.Add(sizer_4, 0, wx.EXPAND, 0)
        self.panel_2.SetAutoLayout(True)
        self.panel_2.SetSizer(sizer_2)
        sizer_2.Fit(self.panel_2)
        sizer_2.SetSizeHints(self.panel_2)
        sizer_1.Add(self.panel_2, 1, wx.EXPAND, 0)
        self.SetAutoLayout(True)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        sizer_1.SetSizeHints(self)
        self.Layout()
        # end wxGlade
        
        self.grid_multiupload.CanDragColSize()
        self.grid_multiupload.Bind(gridlib.EVT_GRID_CELL_LEFT_CLICK, self.OnLeftClickCell)
	self.grid_multiupload.Bind(gridlib.EVT_GRID_CELL_RIGHT_CLICK, self.OnRightClickCell)
	self.Bind(wx.EVT_BUTTON,self.OnButtonAccept,self.button_accept)
	self.Bind(wx.EVT_BUTTON,self.OnButtonCancel,self.button_cancel)
        
        morecd_values = self.Parent.morecd_values
        self.rowlabels = morecd_values["rowlabels"][:]
	self.actions = morecd_values["actions"][:]
	self.content_labels = morecd_values["content_labels"][:]
	self.files = morecd_values["files"][:]
	self.total_cds = morecd_values["total_cds"]
	
        self.grid_multiupload.DeleteRows()
        
	if not len(self.rowlabels):
	    self.InsertNewCd()
	else:
	    self.grid_multiupload.AppendRows(len(self.rowlabels))
	    self.UpdateRows()

	self.grid_multiupload.SetColSize(0,300)
	self.grid_multiupload.SetRowLabelSize(90)
	self.grid_multiupload.SetRowLabelAlignment(wx.ALIGN_RIGHT, wx.ALIGN_CENTRE)
    
    def OnButtonCancel(self,evt):
	self.EndModal(wx.ID_CANCEL)
    def OnButtonAccept(self,evt):
	total_rows = self.grid_multiupload.GetNumberRows()
	
	subs_list = []
	avi_list = []
	for i in range(total_rows):
	    if self.actions[i] == "openvideo":
		avi_list.append(self.files[i])
	    elif self.actions[i] == "opensub":
		subs_list.append(self.files[i])
		    
	total_new_cds = self.total_cds - 2
	last_cd_good = -1
	for cd_count in range(total_new_cds):
	    if avi_list[cd_count] != "" or subs_list[cd_count] != "":
		last_cd_good = cd_count
		
	error_msg = ""
	for cd_count in range(last_cd_good+1):
	     if avi_list[cd_count] == "": 
		 error_msg += "The file for AVI CD" + str(cd_count + 3) + " is required\n"
	     if subs_list[cd_count] == "":
		 error_msg += "The file for Sub CD" + str(cd_count + 3) + " is required\n"
	
	if error_msg != "":
	    wx.MessageBox(error_msg)
	else:    
	    self.Parent.moresubs_list = subs_list[:last_cd_good+1]
	    self.Parent.moreavi_list = avi_list[:last_cd_good+1]
	    morecd_values = {}
	    morecd_values["rowlabels"] = self.rowlabels
	    morecd_values["actions"] = self.actions
	    morecd_values["content_labels"] = self.content_labels
	    morecd_values["files"] = self.files
	    morecd_values["total_cds"] = self.total_cds
	    self.Parent.morecd_values = morecd_values
	
	    self.EndModal(wx.ID_OK)
	
	
    def UpdateRows(self):
	for num,rowlabel in enumerate(self.rowlabels):
	    self.grid_multiupload.SetCellAlignment(num,0,wx.ALIGN_RIGHT, wx.ALIGN_CENTRE)
	    if self.files[num] == "":
		self.grid_multiupload.SetCellValue(num,0,self.content_labels[num])
	    else:
		self.grid_multiupload.SetCellValue(num,0,self.files[num])
	    self.grid_multiupload.SetRowLabelValue(num,rowlabel)
	    
    def AutoCheckGridCds(self):
	total_rows = self.grid_multiupload.GetNumberRows()
	complete = True
	for i in range(total_rows):
	    if self.actions[i] != "" and self.files[i] == "":
                complete = False
		break
	    
	if complete:
	    self.InsertNewCd()
	    
    def InsertNewCd(self):
	total_rows = self.grid_multiupload.GetNumberRows()
	self.total_cds += 1
	
	self.rowlabels.append("AVI File CD"+ str(self.total_cds))
	self.content_labels.append("Browse video...")
	self.files.append("")
	self.actions.append("openvideo")
	
	self.rowlabels.append("Subtitle CD"+ str(self.total_cds))
	self.content_labels.append("Browse subtitle...")
	self.files.append("")
	self.actions.append("opensub")
	
	self.rowlabels.append("...")
	self.content_labels.append("")
	self.files.append("")
	self.actions.append("")
	
	
	
	self.grid_multiupload.AppendRows(3)
	self.UpdateRows()
		
    def OnRightClickCell(self,evt):
	
        self.row_choiced = evt.GetRow()
	self.grid_multiupload.SelectRow(self.row_choiced)
	
	if self.actions[self.row_choiced] == "":
	    evt.Skip()
	    return
    
	if not hasattr(self, "firstpopup"):
		self.firstpopup = True
		self.PopupItemClearItem = wx.NewId()
		self.Bind(wx.EVT_MENU, self.OnPopupClearItem, id=self.PopupItemClearItem)
		
	MyPopupMenu = wx.Menu()
	MyPopupMenu.Append(self.PopupItemClearItem, "Clear Item")
	pos = self.ScreenToClient(wx.GetMousePosition())
	self.PopupMenu(MyPopupMenu, pos)
	MyPopupMenu.Destroy()
	
	evt.Skip()
		
    def OnPopupClearItem(self,evt):
	self.files[self.row_choiced] = ""
	self.UpdateRows()
		
    def OnLeftClickCell(self, evt):


        row = evt.GetRow()
        col = evt.GetCol()
        
	 
        if self.actions[row] == "openvideo":
            dlg = wx.FileDialog(
            self, message="Search the video file:", defaultDir=globals.preferences_list["cwd"], 
            defaultFile="", wildcard="All videos (*.avi;*.mpg)|*.avi;*.mpg|ALL files (*.*)|*.*", style=wx.OPEN |wx.CHANGE_DIR)

	    if dlg.ShowModal() == wx.ID_OK:
		 self.grid_multiupload.SetCellValue(row,col,dlg.GetPath())
		 globals.preferences_list["cwd"] = os.path.dirname(dlg.GetPath())
		 self.files[row] = dlg.GetPath()
		 detect_sub = self.Parent.AutoDetectSubtitle(dlg.GetPath())
		 if detect_sub:
		     self.grid_multiupload.SetCellValue(row+1,col,detect_sub)
		     self.files[row+1] = detect_sub
    		 self.AutoCheckGridCds()
		 
	    dlg.Destroy()
        elif self.actions[row] == "opensub":
            dlg = wx.FileDialog(
            self, message="Search the subtitle file:", defaultDir=globals.preferences_list["cwd"], 
            defaultFile="", wildcard="All subs (*.srt;*.sub;*.txt;*.ssa;*.smi)|*.srt;*.sub;*.txt;*.ssa;*.smi|ALL files (*.*)|*.*", style=wx.OPEN |wx.CHANGE_DIR)

	    if dlg.ShowModal() == wx.ID_OK:
		 self.grid_multiupload.SetCellValue(row,col,dlg.GetPath())
		 globals.preferences_list["cwd"] = os.path.dirname(dlg.GetPath())
		 self.files[row] = dlg.GetPath()
		 self.AutoCheckGridCds()
	    dlg.Destroy()
	    

        evt.Skip()
# end of class MyDialogMoreCds


